package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.dao.custom.base.impl.FindConverterDao;
import com.jasamedika.medifirst2000.entities.PapInstruksiPulang;
import com.jasamedika.medifirst2000.vo.PapInstruksiPulangVO;

/**
 * Converter class PapInstruksiPulang
 * 
 * @author Askur
 */
@Component
public class PapInstruksiPulangConverter extends FindConverterDao implements
		BaseVoConverter<PapInstruksiPulangVO, PapInstruksiPulang> {

	public PapInstruksiPulang transferVOToModel(PapInstruksiPulangVO vo, PapInstruksiPulang model) {
		if (null == model)
			model = new PapInstruksiPulang();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, PapInstruksiPulang.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;

	}

	public List<PapInstruksiPulangVO> transferListOfModelToListOfVO(List<PapInstruksiPulang> models,
			List<PapInstruksiPulangVO> vos) {
		if (null == vos)
			vos = new ArrayList<PapInstruksiPulangVO>();

		if (null == models)
			return vos;

		for (PapInstruksiPulang model : models) {
			PapInstruksiPulangVO vo = new PapInstruksiPulangVO();
			transferModelToVO(model, vo);
			vos.add(vo);
		}

		return vos;
	}

	public PapInstruksiPulangVO transferModelToVO(PapInstruksiPulang model, PapInstruksiPulangVO vo) {
		if (null == vo)
			vo = new PapInstruksiPulangVO();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, PapInstruksiPulangVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
	
}
